//
//  FMController.h
//  MacFM
//
//  Created by KIMURA Hiroaki on 10/05/04.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#include "Operator.h"
#import "WaveView.h"
#import "CoreAudioMixer.h"


#define NUMBER_OF_ARRAY 1000
#define TIME_LENGTH 0.005

@interface FMController : NSObject {
	
	Speaker* speaker;
	int algorithm;
	
	
	double* op1wave;
	double* op2wave;
	double* op3wave;
	double* op4wave;
	double* outwave;
	
	
	FMInfo* op4;
	FMInfo* op3;
	FMInfo* op2;
	FMInfo* op1;

	
	IBOutlet WaveView* wv1;
	IBOutlet WaveView* wv2;
	IBOutlet WaveView* wv3;
	IBOutlet WaveView* wv4;
	IBOutlet WaveView* wv5;
	
	CoreAudioMixer* mixer;
	double carrierFreq;

}


@property double feedbackRate;

@property int algorithm;
@property BOOL op4On;
@property BOOL op3On;
@property BOOL op2On;
@property BOOL op1On;

@property double op1freq;
@property double op2freq;
@property double op3freq;
@property double op4freq;

@property double carrierFreq;

@property double op1mod;
@property double op2mod;
@property double op3mod;
@property double op4mod;


@property double op1attack;
@property double op2attack;
@property double op3attack;
@property double op4attack;

@property double op1decay;
@property double op2decay;
@property double op3decay;
@property double op4decay;

@property double op1sustain;
@property double op2sustain;
@property double op3sustain;
@property double op4sustain;

@property double op1release;
@property double op2release;
@property double op3release;
@property double op4release;



@end
