//
//  FMController.m
//  MacFM
//
//  Created by KIMURA Hiroaki on 10/05/04.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "FMController.h"


@implementation FMController

double animTime = 0.0;


- (id) init{
	algorithm = 0;
	carrierFreq = 440;
	
	op1wave = (double*)malloc(sizeof(double) * NUMBER_OF_ARRAY);
	op2wave = (double*)malloc(sizeof(double) * NUMBER_OF_ARRAY);
	op3wave = (double*)malloc(sizeof(double) * NUMBER_OF_ARRAY);
	op4wave = (double*)malloc(sizeof(double) * NUMBER_OF_ARRAY);

	outwave = (double*)malloc(sizeof(double) * NUMBER_OF_ARRAY);

	
	memset(op1wave, 0, sizeof(double) * NUMBER_OF_ARRAY);
	memset(op2wave, 0, sizeof(double) * NUMBER_OF_ARRAY);
	memset(op3wave, 0, sizeof(double) * NUMBER_OF_ARRAY);
	memset(op4wave, 0, sizeof(double) * NUMBER_OF_ARRAY);
	memset(outwave, 0, sizeof(double) * NUMBER_OF_ARRAY);

	
	speaker = allocSpeaker();
	speaker->numOfParents = 0;
	
	
	op4 = allocFMInfo();
	op3 = allocFMInfo();
	op2 = allocFMInfo();
	op1 = allocFMInfo();

	
	spAddFMInfo(speaker, op4);
	fmAddFmInfo(op4, op3);
	fmAddFmInfo(op3, op2);
	fmAddFmInfo(op2, op1);
	
	setCarrierFreq(op4, carrierFreq);
	
	op3->attack = 0.2;
	op3->decay = 0.3;
	op3->sustain = 0.8;
	op3->release = 0.3;
	op4->release = 1;
	
	mixer = [[CoreAudioMixer alloc] init];
	[mixer setSpeaker:speaker];
	
	
	
	
	return self;	
}

- (void) setFeedbackRate:(double)fb{
	op1->isFB = fb;
	[self calculateWave];

}

- (double)feedbackRate{
	return op1->isFB;
}

- (void) setOp1On:(BOOL)on{
	if (on) {
		op1->isEnabled = true;
	}else {
		op1->isEnabled = false;
	}

	[self calculateWave];

}

- (BOOL) op1On{
	return op1->isEnabled;
}


- (void) setOp2On:(BOOL)on{
	if (on) {
		op2->isEnabled = true;
	}else {
		op2->isEnabled = false;
	}
	
	[self calculateWave];
	
}

- (BOOL) op2On{
	return op2->isEnabled;
}

- (void) setOp3On:(BOOL)on{
	if (on) {
		op3->isEnabled = true;
	}else {
		op3->isEnabled = false;
	}
	
	[self calculateWave];
	
}

- (BOOL) op3On{
	return op3->isEnabled;
}

- (void) setOp4On:(BOOL)on{
	if (on) {
		op4->isEnabled = true;
	}else {
		op4->isEnabled = false;
	}
	
	[self calculateWave];
	
}

- (BOOL) op4On{
	return op4->isEnabled;
}


- (void) awakeFromNib{
	wv1.array = op1wave;
	wv2.array = op2wave;
	wv3.array = op3wave;
	wv4.array = op4wave;
	wv5.array = outwave;
	
	[NSTimer scheduledTimerWithTimeInterval:0.03 
											 target:self
										   selector:@selector(animationTimer:)
										   userInfo:nil
											repeats:YES];
	 
}

- (void)animationTimer:(NSTimer* )timer{
	[self calculateWave];

}



- (void) calculateWave{
	
	double dif = TIME_LENGTH / NUMBER_OF_ARRAY;
	
	double sec = speaker->sec;
	int tmpsec = (int)(sec * op4->carrierFreq);
	sec = 1.0 / op4->carrierFreq * tmpsec;
	
	
	for (int i = 0; i < NUMBER_OF_ARRAY; i++){
		
		outwave[i] = spGetValue(speaker, sec) * 4.0;
		op4wave[i] = fmGetValue(op4, sec) * 4.0 / op4->modIndex;
		op3wave[i] = fmGetValue(op3, sec) * 4.0 / op3->modIndex;
		op2wave[i] = fmGetValue(op2, sec) * 4.0 / op2->modIndex;
		op1wave[i] = fmGetValue(op1, sec) * 4.0 / op1->modIndex;
		
		sec += dif;
	}

	[wv1 setNeedsDisplay:YES];
	[wv2 setNeedsDisplay:YES];
	[wv3 setNeedsDisplay:YES];
	[wv4 setNeedsDisplay:YES];
	[wv5 setNeedsDisplay:YES];	

}



- (void)setCarrierFreq:(double)freq{
	
	carrierFreq = freq;
	for (int i = 0; i < speaker->numOfParents; i++){
		setCarrierFreq(speaker->fms[i], freq);
	}
	[self calculateWave];
}

- (double) carrierFreq{
	return carrierFreq;

}

- (void) setOp4freq:(double)freq{
	op4->freqIndex = freq;
	[self calculateWave];
	
}

- (double) op4freq{
	return op4->freqIndex;
	
}


- (void) setOp3freq:(double)freq{
	op3->freqIndex = freq;
	[self calculateWave];

}

- (double) op3freq{
	return op3->freqIndex;

}

- (void) setOp2freq:(double)freq{
	op2->freqIndex = freq;
	[self calculateWave];

}

- (double) op2freq{
	return op2->freqIndex;
}


- (void) setOp1freq:(double)freq{
	op1->freqIndex = freq;
	[self calculateWave];

}

- (double) op1freq{
	return op1->freqIndex;
}

- (void) setOp4mod:(double)mod{
	op4->modIndex = mod;
	[self calculateWave];
	
}

- (double) op4mod{
	return op4->modIndex;
}



- (void) setOp3mod:(double)mod{
	op3->modIndex = mod;
	[self calculateWave];

}

- (double) op3mod{
	return op3->modIndex;
}

- (void) setOp2mod:(double)mod{
	op2->modIndex = mod;
	[self calculateWave];

}

- (double) op2mod{
	return op2->modIndex;
}

- (void) setOp1mod:(double)mod{
	op1->modIndex = mod;
	[self calculateWave];

}

- (double) op1mod{
	return op1->modIndex;
}

//EG
- (void) setOp4attack:(double)attack{
	op4->attack = attack;
}

- (double) op4attack{
	return op4->attack;
}

- (void) setOp4decay:(double)decay{
	op4->decay = decay;
}

- (double) op4decay{
	return op4->decay;
}

- (void) setOp4sustain:(double)sustain{
	op4->sustain = sustain;
}

- (double) op4sustain{
	return op4->sustain;
}

- (void) setOp4release:(double)release{
	op4->release = release;
}

- (double) op4release{
	return op4->release;
}


- (void) setOp3attack:(double)attack{
	op3->attack = attack;
}

- (double) op3attack{
	return op3->attack;
}

- (void) setOp3decay:(double)decay{
	op3->decay = decay;
}

- (double) op3decay{
	return op3->decay;
}

- (void) setOp3sustain:(double)sustain{
	op3->sustain = sustain;
}

- (double) op3sustain{
	return op3->sustain;
}

- (void) setOp3release:(double)release{
	op3->release = release;
}

- (double) op3release{
	return op3->release;
}

- (void) setOp2attack:(double)attack{
	op2->attack = attack;
}

- (double) op2attack{
	return op2->attack;
}

- (void) setOp2decay:(double)decay{
	op2->decay = decay;
}

- (double) op2decay{
	return op2->decay;
}

- (void) setOp2sustain:(double)sustain{
	op2->sustain = sustain;
}

- (double) op2sustain{
	return op2->sustain;
}

- (void) setOp2release:(double)release{
	op2->release = release;
}

- (double) op2release{
	return op2->release;
}

- (void) setOp1attack:(double)attack{
	op1->attack = attack;
}

- (double) op1attack{
	return op1->attack;
}

- (void) setOp1decay:(double)decay{
	op1->decay = decay;
}

- (double) op1decay{
	return op1->decay;
}

- (void) setOp1sustain:(double)sustain{
	op1->sustain = sustain;
}

- (double) op1sustain{
	return op1->sustain;
}

- (void) setOp1release:(double)release{
	op1->release = release;
}

- (double) op1release{
	return op1->release;
}

- (void) setAlgorithm:(int)num{
	
	if (num == algorithm) {
		return;
	}
	[mixer stopAudio];
	
	algorithm = num;
	spRemoveAllFMInfo(speaker);
	fmRemoveAllFMInfo(op1);
	fmRemoveAllFMInfo(op2);
	fmRemoveAllFMInfo(op3);
	fmRemoveAllFMInfo(op4);

	
	switch (algorithm) {
		case 0:
			spAddFMInfo(speaker, op4);
			fmAddFmInfo(op4, op3);
			fmAddFmInfo(op3, op2);
			fmAddFmInfo(op2, op1);
			break;
		case 1:
			spAddFMInfo(speaker, op4);
			fmAddFmInfo(op4, op3);
			fmAddFmInfo(op3, op2);
			fmAddFmInfo(op3, op1);
			break;
		case 2:
			spAddFMInfo(speaker, op4);
			fmAddFmInfo(op4, op1);
			fmAddFmInfo(op4, op3);
			fmAddFmInfo(op3, op2);
			break;
		case 3:
			spAddFMInfo(speaker, op4);
			fmAddFmInfo(op4, op3);
			fmAddFmInfo(op4, op2);
			fmAddFmInfo(op2, op1);
			break;
		case 4:
			spAddFMInfo(speaker, op4);
			fmAddFmInfo(op4, op3);
			spAddFMInfo(speaker, op2);
			fmAddFmInfo(op2, op1);
			break;
		case 5:
			spAddFMInfo(speaker, op4);
			spAddFMInfo(speaker, op3);
			spAddFMInfo(speaker, op2);

			fmAddFmInfo(op2, op1);
			fmAddFmInfo(op3, op1);
			fmAddFmInfo(op4, op1);
			break;
			
		case 6:
			spAddFMInfo(speaker, op4);
			spAddFMInfo(speaker, op3);
			spAddFMInfo(speaker, op2);
			
			fmAddFmInfo(op2, op1);
			break;
		case 7:
			spAddFMInfo(speaker, op4);
			spAddFMInfo(speaker, op3);
			spAddFMInfo(speaker, op2);
			spAddFMInfo(speaker, op1);
			break;
		
		default:
			break;
	}
	
	[mixer startAudio];
}



@end
