/*
 *  Operator.h
 *  MacFM
 *
 *  Created by KIMURA Hiroaki on 10/05/04.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */


#define SAMPLE_RATE 44100.0


#include <stdio.h>
#include <stdlib.h>
#include <math.h>

typedef struct _FMInfo FMInfo;
typedef struct _FMList FMList;
typedef struct _Speaker Speaker;

struct _Speaker{
	int numOfParents;
	double sec;
	FMInfo** fms;
};

struct _FMInfo{
	double isFB;
	int isEnabled;
	
	double carrierFreq;
	double freqIndex;
	double modIndex;
	
	double attack;
	double decay;
	double sustain;
	double release;
	
	int numOfParents;
	FMInfo** parents;
};


FMInfo* allocFMInfo();
Speaker* allocSpeaker();

void fmRemoveAllFMInfo(FMInfo* fm);
void spRemoveAllFMInfo(Speaker* sp);
void fmRemoveFmInfo(FMInfo* fm, FMInfo* removed);
void spRemoveFmInfo(Speaker* sp, FMInfo* removed);
double fmGetValue(FMInfo* fm, double sec);
double fmGetValueDefault(FMInfo* fm, double sec);
double spGetValue(Speaker* speaker, double sec);
void spAddFMInfo(Speaker* speaker, FMInfo* addedFM);
void fmAddFmInfo(FMInfo* fm, FMInfo* addedFM);
void setCarrierFreq(FMInfo* carrier, double freq);
